diff --git a/src/main/java/net/minecraft/core/net/command/commands/FillCommand.java b/src/main/java/net/minecraft/core/net/command/commands/FillCommand.java
new file mode 100644
index 000000000..0ef81bbe1
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/commands/FillCommand.java
@@ -0,0 +1,214 @@
+package net.minecraft.core.net.command.commands;
+
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.BlockArgumentType;
+import net.minecraft.core.net.command.arguments.IntegerCoordinatesArgumentType;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import net.minecraft.core.net.command.helpers.BlockInput;
+import net.minecraft.core.net.command.helpers.IntegerCoordinates;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
+
+public class FillCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("fill")
+            .requires(CommandSource::hasAdmin)
+            .then(RequiredArgumentBuilder.<CommandSource, IntegerCoordinates>argument("first", IntegerCoordinatesArgumentType.intCoordinates())
+                .then(RequiredArgumentBuilder.<CommandSource, IntegerCoordinates>argument("second", IntegerCoordinatesArgumentType.intCoordinates())
+                    .then(RequiredArgumentBuilder.<CommandSource, BlockInput>argument("block", BlockArgumentType.block())
+                        .executes(c -> {
+                            IntegerCoordinates first = c.getArgument("first", IntegerCoordinates.class);
+                            IntegerCoordinates second = c.getArgument("second", IntegerCoordinates.class);
+                            BlockInput block = c.getArgument("block", BlockInput.class);
+                            if (CommandHelper.getVolume(c.getSource(), first, second) > 32768)
+                                throw CommandExceptions.volumeTooLarge().create();
+                            int blocksFilled = fillReplace(c.getSource(), c.getSource().getWorld(), first, second, block);
+                            c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "commands.fill.success_multiple", blocksFilled);
+                            return blocksFilled;
+                        })
+                        .then(LiteralArgumentBuilder.<CommandSource>literal("replace")
+                            .executes(c -> {
+                                IntegerCoordinates first = c.getArgument("first", IntegerCoordinates.class);
+                                IntegerCoordinates second = c.getArgument("second", IntegerCoordinates.class);
+                                BlockInput block = c.getArgument("block", BlockInput.class);
+                                if (CommandHelper.getVolume(c.getSource(), first, second) > 32768)
+                                    throw CommandExceptions.volumeTooLarge().create();
+                                int blocksFilled = fillReplace(c.getSource(), c.getSource().getWorld(), first, second, block);
+                                c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "commands.fill.success_multiple", blocksFilled);
+                                return blocksFilled;
+                            })
+                            .then(RequiredArgumentBuilder.<CommandSource, BlockInput>argument("filter", BlockArgumentType.block())
+                                .executes(c -> {
+                                    IntegerCoordinates first = c.getArgument("first", IntegerCoordinates.class);
+                                    IntegerCoordinates second = c.getArgument("second", IntegerCoordinates.class);
+                                    BlockInput block = c.getArgument("block", BlockInput.class);
+                                    BlockInput filter = c.getArgument("filter", BlockInput.class);
+                                    if (CommandHelper.getVolume(c.getSource(), first, second) > 32768)
+                                        throw CommandExceptions.volumeTooLarge().create();
+                                    int blocksFilled = fillReplace(c.getSource(), c.getSource().getWorld(), first, second, block, filter);
+                                    c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "commands.fill.success_multiple", blocksFilled);
+                                    return blocksFilled;
+                                })))
+                        .then(LiteralArgumentBuilder.<CommandSource>literal("hollow")
+                            .executes(c -> {
+                                IntegerCoordinates first = c.getArgument("first", IntegerCoordinates.class);
+                                IntegerCoordinates second = c.getArgument("second", IntegerCoordinates.class);
+                                BlockInput block = c.getArgument("block", BlockInput.class);
+                                if (CommandHelper.getVolume(c.getSource(), first, second) > 32768)
+                                    throw CommandExceptions.volumeTooLarge().create();
+                                int blocksFilled = fillHollow(c.getSource(), c.getSource().getWorld(), first, second, block);
+                                c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "commands.fill.success_multiple", blocksFilled);
+                                return blocksFilled;
+                            }))
+                        .then(LiteralArgumentBuilder.<CommandSource>literal("outline")
+                            .executes(c -> {
+                                IntegerCoordinates first = c.getArgument("first", IntegerCoordinates.class);
+                                IntegerCoordinates second = c.getArgument("second", IntegerCoordinates.class);
+                                BlockInput block = c.getArgument("block", BlockInput.class);
+                                if (CommandHelper.getVolume(c.getSource(), first, second) > 32768)
+                                    throw CommandExceptions.volumeTooLarge().create();
+                                int blocksFilled = fillOutline(c.getSource(), c.getSource().getWorld(), first, second, block);
+                                c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "commands.fill.success_multiple", blocksFilled);
+                                return blocksFilled;
+                            }))
+                        .then(LiteralArgumentBuilder.<CommandSource>literal("keep")
+                            .executes(c -> {
+                                IntegerCoordinates first = c.getArgument("first", IntegerCoordinates.class);
+                                IntegerCoordinates second = c.getArgument("second", IntegerCoordinates.class);
+                                BlockInput block = c.getArgument("block", BlockInput.class);
+                                if (CommandHelper.getVolume(c.getSource(), first, second) > 32768)
+                                    throw CommandExceptions.volumeTooLarge().create();
+                                int blocksFilled = fillKeep(c.getSource(), c.getSource().getWorld(), first, second, block);
+                                c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "commands.fill.success_multiple", blocksFilled);
+                                return blocksFilled;
+                            }))
+                        .then(LiteralArgumentBuilder.<CommandSource>literal("destroy")
+                            .executes(c -> {
+                                IntegerCoordinates first = c.getArgument("first", IntegerCoordinates.class);
+                                IntegerCoordinates second = c.getArgument("second", IntegerCoordinates.class);
+                                BlockInput block = c.getArgument("block", BlockInput.class);
+                                if (CommandHelper.getVolume(c.getSource(), first, second) > 32768)
+                                    throw CommandExceptions.volumeTooLarge().create();
+                                int blocksFilled = fillDestroy(c.getSource(), c.getSource().getWorld(), first, second, block);
+                                c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "commands.fill.success_multiple", blocksFilled);
+                                return blocksFilled;
+                            }))))));
+    }
+
+    public static int fillReplace(CommandSource source, World world, IntegerCoordinates first, IntegerCoordinates second, BlockInput block) throws CommandSyntaxException {
+        return fillReplace(source, world, first, second, block, null);
+    }
+
+    public static int fillReplace(CommandSource source, World world, IntegerCoordinates first, IntegerCoordinates second, BlockInput block, @Nullable BlockInput filter) throws CommandSyntaxException {
+        return fillReplace(source, world, first, second, block, filter, false);
+    }
+
+    public static int fillReplace(CommandSource source, World world, IntegerCoordinates first, IntegerCoordinates second, BlockInput block, @Nullable BlockInput filter, boolean destroy) throws CommandSyntaxException {
+        world.editingBlocks = true;
+        int minX = Math.min(first.getX(source), second.getX(source));
+        int minY = Math.min(first.getY(source, true), second.getY(source, true));
+        int minZ = Math.min(first.getZ(source), second.getZ(source));
+        int maxX = Math.max(first.getX(source), second.getX(source));
+        int maxY = Math.max(first.getY(source, true), second.getY(source, true));
+        int maxZ = Math.max(first.getZ(source), second.getZ(source));
+
+        int blocksFilled = 0;
+        for (int x = minX; x <= maxX; x++) {
+            for (int y = minY; y <= maxY; y++) {
+                for (int z = minZ; z <= maxZ; z++) {
+                    CompoundTag blockTag = new CompoundTag();
+                    BlockEntity blockEntity = world.getBlockEntity(x, y, z);
+                    if (blockEntity != null) blockEntity.writeToNBT(blockTag);
+                    if ((block.getBlockId() != world.getBlockId(x, y, z) || block.getMetadata() != world.getBlockMetadata(x, y, z) || !CommandHelper.blockEntitiesAreEqual(block.getTag(), CommandHelper.tagFrom(world.getBlockEntity(x, y, z)))) && (filter == null || (world.getBlockId(x, y, z) == filter.getBlockId() && world.getBlockMetadata(x, y, z) == filter.getMetadata() && (filter.getTag().getValues().isEmpty() || CommandHelper.blockEntitiesAreEqual(blockTag, filter.getTag()))))) {
+                        ++blocksFilled;
+                        if (destroy && world.getBlock(x, y, z) != null)
+                            world.getBlock(x, y, z).getBreakResult(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), world.getBlockEntity(x, y, z));
+                    }
+                    if (filter == null || (world.getBlockId(x, y, z) == filter.getBlockId() && world.getBlockMetadata(x, y, z) == filter.getMetadata() && (!filter.getTag().getValue().isEmpty() || CommandHelper.blockEntitiesAreEqual(CommandHelper.tagFrom(world.getBlockEntity(x, y, z)), filter.getTag())))) {
+                        world.setBlockWithNotify(x, y, z, block.getBlockId());
+                        world.setBlockMetadataWithNotify(x, y, z, block.getMetadata());
+                        CommandHelper.setBlockEntity(world, x, y, z, block.getTag());
+                    }
+                }
+            }
+        }
+        world.editingBlocks = false;
+
+        return blocksFilled;
+    }
+
+    public static int fillHollow(CommandSource source, World world, IntegerCoordinates first, IntegerCoordinates second, BlockInput block) throws CommandSyntaxException {
+        world.editingBlocks = true;
+        int minX = Math.min(first.getX(source), second.getX(source));
+        int minY = Math.min(first.getY(source, true), second.getY(source, true));
+        int minZ = Math.min(first.getZ(source), second.getZ(source));
+        int maxX = Math.max(first.getX(source), second.getX(source));
+        int maxY = Math.max(first.getY(source, true), second.getY(source, true));
+        int maxZ = Math.max(first.getZ(source), second.getZ(source));
+
+        int blocksFilled = 0;
+        for (int x = minX; x <= maxX; x++) {
+            for (int y = minY; y <= maxY; y++) {
+                for (int z = minZ; z <= maxZ; z++) {
+                    boolean isOutline = x == minX || x == maxX || y == minY || y == maxY || z == minZ || z == maxZ;
+                    if ((isOutline && (block.getBlockId() != world.getBlockId(x, y, z) || block.getMetadata() != world.getBlockMetadata(x, y, z) || !CommandHelper.blockEntitiesAreEqual(block.getTag(), CommandHelper.tagFrom(world.getBlockEntity(x, y, z))))) || (!isOutline && world.getBlockId(x, y, z) != 0)) {
+                        ++blocksFilled;
+                        if (!isOutline && world.getBlock(x, y, z) != null)
+                            world.getBlock(x, y, z).getBreakResult(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), world.getBlockEntity(x, y, z));
+                    }
+                    world.setBlockWithNotify(x, y, z, isOutline ? block.getBlockId() : 0);
+                    world.setBlockMetadataWithNotify(x, y, z, isOutline ? block.getMetadata() : 0);
+                    CommandHelper.setBlockEntity(world, x, y, z, block.getTag());
+                }
+            }
+        }
+        world.editingBlocks = false;
+
+        return blocksFilled;
+    }
+
+    public static int fillOutline(CommandSource source, World world, IntegerCoordinates first, IntegerCoordinates second, BlockInput block) throws CommandSyntaxException {
+        world.editingBlocks = true;
+        int minX = Math.min(first.getX(source), second.getX(source));
+        int minY = Math.min(first.getY(source, true), second.getY(source, true));
+        int minZ = Math.min(first.getZ(source), second.getZ(source));
+        int maxX = Math.max(first.getX(source), second.getX(source));
+        int maxY = Math.max(first.getY(source, true), second.getY(source, true));
+        int maxZ = Math.max(first.getZ(source), second.getZ(source));
+
+        int blocksFilled = 0;
+        for (int x = minX; x <= maxX; x++) {
+            for (int y = minY; y <= maxY; y++) {
+                for (int z = minZ; z <= maxZ; z++) {
+                    boolean isOutline = x == minX || x == maxX || y == minY || y == maxY || z == minZ || z == maxZ;
+                    if (isOutline && (block.getBlockId() != world.getBlockId(x, y, z) || block.getMetadata() != world.getBlockMetadata(x, y, z) || !CommandHelper.blockEntitiesAreEqual(block.getTag(), CommandHelper.tagFrom(world.getBlockEntity(x, y, z)))))
+                        ++blocksFilled;
+                    if (isOutline) {
+                        world.setBlockWithNotify(x, y, z, block.getBlockId());
+                        world.setBlockMetadataWithNotify(x, y, z, block.getMetadata());
+                        CommandHelper.setBlockEntity(world, x, y, z, block.getTag());
+                    }
+                }
+            }
+        }
+        world.editingBlocks = false;
+
+        return blocksFilled;
+    }
+
+    public static int fillKeep(CommandSource source, World world, IntegerCoordinates first, IntegerCoordinates second, BlockInput block) throws CommandSyntaxException {
+        return fillReplace(source, world, first, second, block, new BlockInput(null, 0, new CompoundTag()));
+    }
+
+    public static int fillDestroy(CommandSource source, World world, IntegerCoordinates first, IntegerCoordinates second, BlockInput block) throws CommandSyntaxException {
+        return fillReplace(source, world, first, second, block, null, true);
+    }
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/net/command/commands/GameModeCommand.java b/src/main/java/net/minecraft/core/net/command/commands/GameModeCommand.java
new file mode 100644
index 000000000..fbf3b7865
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/commands/GameModeCommand.java
@@ -0,0 +1,63 @@
+package net.minecraft.core.net.command.commands;
+
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.EntityArgumentType;
+import net.minecraft.core.net.command.arguments.GameModeArgumentType;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import net.minecraft.core.net.command.helpers.EntitySelector;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.player.gamemode.Gamemode;
+
+import java.util.List;
+
+public class GameModeCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("gamemode")
+            .requires(CommandSource::hasAdmin)
+            .then(RequiredArgumentBuilder.<CommandSource, Gamemode>argument("gamemode", GameModeArgumentType.gameMode())
+                .executes(c -> {
+                    CommandSource source = c.getSource();
+                    Gamemode gameMode = c.getArgument("gamemode", Gamemode.class);
+
+                    if (source.getSender() == null) {
+                        throw CommandExceptions.notInWorld().create();
+                    }
+
+                    source.getSender().setGamemode(gameMode);
+                    source.sendTranslatableMessage("command.commands.gamemode.success_self", I18n.getInstance().translateKey(gameMode.getLanguageKey() + ".name"));
+                    return Command.SINGLE_SUCCESS;
+                })
+                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("targets", EntityArgumentType.players())
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        Gamemode gameMode = c.getArgument("gamemode", Gamemode.class);
+                        EntitySelector entitySelector = c.getArgument("targets", EntitySelector.class);
+
+                        List<? extends Entity> entities = entitySelector.get(c.getSource());
+
+                        for (Entity entity : entities) {
+                            ((Player) entity).setGamemode(gameMode);
+                            if (entity != source.getSender()) {
+                                source.sendTranslatableMessage((Player) entity, "command.commands.gamemode.success_receiver");
+                            }
+                        }
+
+                        if (entities.size() == 1) {
+                            if (entities.get(0) == source.getSender()) {
+                                source.sendTranslatableMessage("command.commands.gamemode.success_self", I18n.getInstance().translateKey(gameMode.getLanguageKey() + ".name"));
+                            } else {
+                                source.sendTranslatableMessage("command.commands.gamemode.success_other", CommandHelper.getEntityName(entities.get(0)), I18n.getInstance().translateKey(gameMode.getLanguageKey() + ".name"));
+                            }
+                        }
+                        return Command.SINGLE_SUCCESS;
+                    })))
+        );
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/commands/GameRuleCommand.java b/src/main/java/net/minecraft/core/net/command/commands/GameRuleCommand.java
new file mode 100644
index 000000000..b05c38594
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/commands/GameRuleCommand.java
@@ -0,0 +1,48 @@
+package net.minecraft.core.net.command.commands;
+
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.arguments.BoolArgumentType;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.tree.CommandNode;
+import net.minecraft.core.data.gamerule.GameRule;
+import net.minecraft.core.data.gamerule.GameRuleBoolean;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.GenericGameRuleArgumentType;
+
+public class GameRuleCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        final LiteralArgumentBuilder<CommandSource> argumentBuilder = LiteralArgumentBuilder.<CommandSource>literal("gamerule").requires(CommandSource::hasAdmin);
+        for (final GameRule<?> gameRule : Registries.GAME_RULES) {
+            RequiredArgumentBuilder<CommandSource, ?> gameRuleValueArgument;
+            if (gameRule instanceof GameRuleBoolean) {
+                gameRuleValueArgument = RequiredArgumentBuilder.<CommandSource, Boolean>argument("value", BoolArgumentType.bool())
+                        .executes(c -> {
+                            c.getSource().getWorld().getLevelData().getGameRules().setValue((GameRule<? super Object>) gameRule, BoolArgumentType.getBool(c, "value"));
+                            c.getSource().sendTranslatableMessage("command.commands.gamerule.set", gameRule.getKey(), BoolArgumentType.getBool(c, "value"));
+                            return Command.SINGLE_SUCCESS;
+                        });
+            } else {
+                gameRuleValueArgument = RequiredArgumentBuilder.<CommandSource, Object>argument("value", GenericGameRuleArgumentType.gameRule(gameRule))
+                        .executes(c -> {
+                            Object o = c.getArgument("value", Object.class);
+                            c.getSource().getWorld().getLevelData().getGameRules().setValue((GameRule<? super Object>) gameRule, o);
+                            c.getSource().sendTranslatableMessage("command.commands.gamerule.set", gameRule.getKey(), o);
+                            return Command.SINGLE_SUCCESS;
+                        });
+            }
+            argumentBuilder.then(LiteralArgumentBuilder.<CommandSource>literal(gameRule.getKey())
+                    .executes(c -> {
+                        c.getSource().sendTranslatableMessage("command.commands.gamerule.get", gameRule.getKey(), c.getSource().getWorld().getGameRuleValue(gameRule));
+                        return Command.SINGLE_SUCCESS;
+                    })
+                    .then(gameRuleValueArgument));
+        }
+        CommandNode<CommandSource> commandNode = dispatcher.register(argumentBuilder);
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("gr")
+                .requires(CommandSource::hasAdmin)
+                .redirect(commandNode));
+    }
+}
